/*
    tcp.c: tcp log part of Tcp Listen
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/

#define D_POSIX_SOURCE
#include <stdio.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <syslog.h>

int log_tcp (struct tcphdr *tcp, struct iphdr *ip, struct in_addr add, char syslogg)
{
char logstring [256];
char aux [256];

memset (aux, '\0', sizeof (aux));
memset (logstring, '\0', sizeof (logstring));

add.s_addr = ip->saddr;
sprintf (logstring, "TCP: %s:%d > ", inet_ntoa (add.s_addr), ntohs
							(tcp->source));
add.s_addr = ip->daddr;
sprintf (aux, "%s:%d ", inet_ntoa (add.s_addr), ntohs (tcp->dest));
strcat (logstring, aux);
memset (aux, '\0', sizeof (aux));

sprintf (aux, "ttl: %d win: %d seq: %d ack: %d f: ", ip->ttl,
					ntohs (tcp->window), tcp->seq,
					ntohl (tcp->ack_seq)); 
strcat (logstring, aux);
memset (aux, '\0', sizeof (aux));

if (tcp->syn) strcat (aux, "syn ");
if (tcp->fin) strcat (aux, "fin ");
if (tcp->rst) strcat (aux, "rst ");
if (tcp->ack) strcat (aux, "ack ");
if (tcp->psh) strcat (aux, "psh ");
if (tcp->urg) strcat (aux, "urg ");
strcat (aux, "\n");
strcat (logstring, aux);
if (!syslogg) printf ("%s", logstring); else syslog (LOG_INFO, logstring);
return (0);
}
